/* Generated By:JavaCC: Do not edit this line. MGTPPre.java */
import java.io.*;
import java.util.*;

public class MGTPPre implements MGTPPreConstants {
  static String version="2.4.6";
  static String fileName="foo.mg";
  static String fileName1="foox.mg";
  static String fileName2="foox.java";
  static String ANTE="ante".intern();
  static String IVAR="ivar".intern();
  static String XVAR="xvar".intern();
  static long time;
  FileOutputStream exFile1;
  DataOutputStream outStr1;
  FileOutputStream exFile2;
  DataOutputStream outStr2;
  int clsId=1;
  Hashtable avDict=new Hashtable();
  Hashtable cvDict=new Hashtable();
  boolean excode;
  Vector ivar=new Vector();
  Vector xvar=new Vector();
  String excall="";
  String excodeHdr="";
  String excodeCond="";
  String excodeDecl="";
  String excodeBody="";
  String excodeRet="";
  String excodeFot="";

  static public void main(String args[]) {
    time=System.currentTimeMillis();
    MGTPPre preprocessor=null;

    if (args.length==0) {
      System.out.println("MGTP Preprocessor Version "+version+": "
                          +"Reading from standard input...");
      preprocessor=new MGTPPre(System.in);
    } else if (args.length>=1) {
      fileName=args[0];
      System.out.println("MGTP Preprocessor Version "+version+": "
                          +"Reading from file "+fileName+"...");
      try {
         preprocessor=new MGTPPre(new FileInputStream(fileName));
      } catch (FileNotFoundException e) {
         System.out.println("MGTP Preprocessor Version "+version+": "
                            +" File "+fileName+" not found.");
      }
    } else {
      System.out.println("MGTP Preprocessor Version "+version+": "
                          +": Usage is one of:");
      System.out.println("         java MGTPPre < inputfile");
      System.out.println("OR");
      System.out.println("         java MGTPPre inputfile");
    }
    try {
      fileName=fileName.substring(fileName.lastIndexOf("/")+1);
      fileName=fileName.substring(0,fileName.lastIndexOf("."));
      fileName1="./"+fileName+"x.mg";
      fileName2="./"+fileName+"x.java";
      preprocessor.exFile1=new FileOutputStream(fileName1);
      preprocessor.outStr1=new DataOutputStream(preprocessor.exFile1);
      preprocessor.exFile2=new FileOutputStream(fileName2);
      preprocessor.outStr2=new DataOutputStream(preprocessor.exFile2);
      preprocessor.outStr2.writeBytes(preprocessor.excodeHdr);
      preprocessor.CompilationUnit();
      preprocessor.outStr2.writeBytes(preprocessor.excodeFot);
      preprocessor.outStr1.close();
      preprocessor.exFile1.close();
      preprocessor.outStr2.close();
      preprocessor.exFile2.close();
      System.out.println("MGTP Preprocessor Version "+version+": "
                          +"MGTP input clauses parsed successfully.");
      time=System.currentTimeMillis()-time;
      System.out.print("Preprocessing time: "+time+" msec\n");
    } catch (IOException e) {
      System.out.print("File IO exception!!\n");
    } catch (ParseError e) {
      System.out.println("MGTP Preprocessor Version "+version+": "
                          +" Encountered errors during parse.");
    }
  }

  static void mkIvar(MGTPPre p) {
    if (p.ivar.size()==0) {
      p.excall=p.excall+"],";
      return;
    }
    String s; int i;
    for (i=0; i<p.ivar.size()-1; i++) {
      s=((String)p.ivar.elementAt(i)).intern();
      if (null!=p.avDict.get(s)) {
         p.excall=p.excall+s+",";
         p.excodeDecl=p.excodeDecl+"    int "+s+"="
           +"((ITerm)iVars["+i+"].arg).val;\n";
      }
    }
    s=((String)p.ivar.elementAt(i)).intern();
    p.excall=p.excall+s+"],";
    p.excodeDecl=p.excodeDecl+"    int "+s+"="
      +"((ITerm)iVars["+i+"].arg).val;\n";
  }

  static void mkOvar(MGTPPre p) {
    if (p.xvar.size()==0) {
      p.excall=p.excall+"[])}";
      p.excodeRet=p.excodeRet+"\u0009return true;\n  }\n}\n\n";
      return;
    }
    p.excall=p.excall+"[";
    boolean firstV=true;
    String s; int i;
    for (i=0; i<p.xvar.size(); i++) {
      s=((String)p.xvar.elementAt(i)).intern();
      p.excodeDecl=p.excodeDecl+"    int "+s+";\n";
      if (null!=p.cvDict.get(s)) {
         if (firstV) {
           p.excall=p.excall+s; firstV=false;
         } else {
           p.excall=p.excall+","+s;
         }
         p.excodeRet=p.excodeRet+"    oVars["+i+"].arg="
           +"new ITerm("+s+");\n";
      }
    }
    p.excall=p.excall+"])}";
    p.excodeRet=p.excodeRet+"    return true;\n  }\n}\n\n";
  }

/*****************************************
 * THE MGTP LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/
  final public void CompilationUnit() throws ParseError {
    label_1:
    while (true) {
      if (jj_mask_0[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[0] = jj_gen;
        break label_1;
      }
      Clause();
    }
    jj_consume_token(0);
  }

  static boolean[] jj_mask_0 = new boolean[66];
  static {
    jj_mask_0[ANONVAR] =
    jj_mask_0[VIDENTIFIER] =
    jj_mask_0[CIDENTIFIER] =
    jj_mask_0[INTEGER] =
    jj_mask_0[LBRACE] =
    jj_mask_0[IMPLIES] =
    jj_mask_0[LONGIMPLIES] = true;
  }
  
  final public void Clause() throws ParseError {
         String ant=""; String cns=""; avDict.clear(); cvDict.clear();
         excode=false; ivar=new Vector(); xvar=new Vector();
         excall="{"+MGTPPre.fileName+"_"+"cond"+clsId+"([";
         excodeCond="class "+MGTPPre.fileName+"_"+"cond"+clsId
           +" extends MGTPExternal {\n  public "+MGTPPre.fileName
           +"_"+"cond"+clsId+"() {}\n  boolean eval() {\n";
         excodeDecl="";
         excodeBody="";
         excodeRet="";
    if (jj_mask_1[getToken(1).kind]) {
      ant = Antecedent();
    } else {
      jj_expLA1[1] = jj_gen;
      ;
    }
    if (jj_mask_3[getToken(1).kind]) {
      jj_consume_token(IMPLIES);
    } else {
      jj_expLA1[3] = jj_gen;
      if (jj_mask_2[getToken(1).kind]) {
        jj_consume_token(LONGIMPLIES);
      } else {
        jj_expLA1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
    if (jj_mask_4[getToken(1).kind]) {
      cns = Consequent();
    } else {
      jj_expLA1[4] = jj_gen;
      ;
    }
    jj_consume_token(DOT);
         MGTPPre.mkIvar(this);
         MGTPPre.mkOvar(this);
         if (excode) {
             try {
                 outStr1.writeBytes(ant+excall+"->"+cns+".\n");
             } catch (IOException e) {
             }
             try {
                 outStr2.writeBytes(excodeCond
                                    +excodeDecl+excodeBody+excodeRet);
             } catch (IOException e) {
             }
         } else {
             try {
                 outStr1.writeBytes(ant+"->"+cns+".\n");
             } catch (IOException e) {
             }
         }
         clsId++;
  }

  static boolean[] jj_mask_1 = new boolean[66];
  static {
    jj_mask_1[ANONVAR] =
    jj_mask_1[VIDENTIFIER] =
    jj_mask_1[CIDENTIFIER] =
    jj_mask_1[INTEGER] =
    jj_mask_1[LBRACE] = true;
  }
  static boolean[] jj_mask_2 = new boolean[66];
  static {
    jj_mask_2[LONGIMPLIES] = true;
  }
  static boolean[] jj_mask_3 = new boolean[66];
  static {
    jj_mask_3[IMPLIES] = true;
  }
  static boolean[] jj_mask_4 = new boolean[66];
  static {
    jj_mask_4[ANONVAR] =
    jj_mask_4[VIDENTIFIER] =
    jj_mask_4[CIDENTIFIER] =
    jj_mask_4[INTEGER] =
    jj_mask_4[LBRACE] = true;
  }
  
  final public String Antecedent() throws ParseError {
         String ant; String lit;
    lit = Literal(0);
         ant=lit;
    label_2:
    while (true) {
      if (jj_mask_5[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[5] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
      lit = Literal(0);
         ant=ant+","+lit;
    }
         return ant;
  }

  static boolean[] jj_mask_5 = new boolean[66];
  static {
    jj_mask_5[COMMA] = true;
  }
  
  final public String Consequent() throws ParseError {
         String cns; String cnj;
    cnj = Conjunction();
         cns=cnj;
    label_3:
    while (true) {
      if (jj_mask_6[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[6] = jj_gen;
        break label_3;
      }
      jj_consume_token(SEMICOLON);
      cnj = Conjunction();
         cns=cns+";"+cnj;
    }
         return cns;
  }

  static boolean[] jj_mask_6 = new boolean[66];
  static {
    jj_mask_6[SEMICOLON] = true;
  }
  
  final public String Conjunction() throws ParseError {
         String cnj; String lit;
    lit = Literal(1);
         cnj=lit;
    label_4:
    while (true) {
      if (jj_mask_7[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[7] = jj_gen;
        break label_4;
      }
      jj_consume_token(COMMA);
      lit = Literal(1);
         cnj=cnj+","+lit;
    }
         return cnj;
  }

  static boolean[] jj_mask_7 = new boolean[66];
  static {
    jj_mask_7[COMMA] = true;
  }
  
  final public String Literal(int i) throws ParseError {
         String t;
    if (jj_mask_9[getToken(1).kind]) {
      t = Term(i);
         return t;
    } else {
      jj_expLA1[9] = jj_gen;
      if (jj_mask_8[getToken(1).kind]) {
        t = ExternalLiteral();
         excode=true;
         excodeBody=t;
         return "";
      } else {
        jj_expLA1[8] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_8 = new boolean[66];
  static {
    jj_mask_8[LBRACE] = true;
  }
  static boolean[] jj_mask_9 = new boolean[66];
  static {
    jj_mask_9[ANONVAR] =
    jj_mask_9[VIDENTIFIER] =
    jj_mask_9[CIDENTIFIER] =
    jj_mask_9[INTEGER] = true;
  }
  
  final public String Term(int i) throws ParseError {
         Token x; String code=""; String a;
    if (jj_mask_14[getToken(1).kind]) {
      x = jj_consume_token(CIDENTIFIER);
         code=x.image;
      if (jj_mask_13[getToken(1).kind]) {
        jj_consume_token(LPAREN);
        a = TermList(i);
        jj_consume_token(RPAREN);
         code=code+"("+a+")";
      } else {
        jj_expLA1[13] = jj_gen;
        ;
      }
         return code;
    } else {
      jj_expLA1[14] = jj_gen;
      if (jj_mask_12[getToken(1).kind]) {
        x = jj_consume_token(ANONVAR);
         return x.image;
      } else {
        jj_expLA1[12] = jj_gen;
        if (jj_mask_11[getToken(1).kind]) {
          x = jj_consume_token(VIDENTIFIER);
         switch (i) {
           case 0:
             avDict.put(x.image.intern(),MGTPPre.ANTE); break;
           case 1:
             cvDict.put(x.image.intern(),x.image.intern()); break;
         }
         return x.image;
        } else {
          jj_expLA1[11] = jj_gen;
          if (jj_mask_10[getToken(1).kind]) {
            x = jj_consume_token(INTEGER);
         return x.image;
          } else {
            jj_expLA1[10] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_10 = new boolean[66];
  static {
    jj_mask_10[INTEGER] = true;
  }
  static boolean[] jj_mask_11 = new boolean[66];
  static {
    jj_mask_11[VIDENTIFIER] = true;
  }
  static boolean[] jj_mask_12 = new boolean[66];
  static {
    jj_mask_12[ANONVAR] = true;
  }
  static boolean[] jj_mask_13 = new boolean[66];
  static {
    jj_mask_13[LPAREN] = true;
  }
  static boolean[] jj_mask_14 = new boolean[66];
  static {
    jj_mask_14[CIDENTIFIER] = true;
  }
  
  final public String TermList(int i) throws ParseError {
         String t; String code="";
    t = Term(i);
         code=t;
    label_5:
    while (true) {
      if (jj_mask_15[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[15] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      t = Term(i);
         code=code+","+t;
    }
         return code;
  }

  static boolean[] jj_mask_15 = new boolean[66];
  static {
    jj_mask_15[COMMA] = true;
  }
  
/**
 * Extended MGTP clauses are allowed to be written nsuch as:
 *   p(X), {X1:=X+1, X1<=100} --> p(X1).
 */
  final public String ExternalLiteral() throws ParseError {
         String code=""; Vector vlist=new Vector(); String s;
    jj_consume_token(LBRACE);
    s = Formula(vlist);
         code=code+s;
    label_6:
    while (true) {
      if (jj_mask_16[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[16] = jj_gen;
        break label_6;
      }
      jj_consume_token(COMMA);
      s = Formula(vlist);
         code=code+s;
    }
    jj_consume_token(RBRACE);
         return code;
  }

  static boolean[] jj_mask_16 = new boolean[66];
  static {
    jj_mask_16[COMMA] = true;
  }
  
  final public String Formula(Vector vlist) throws ParseError {
         Token x; String lft; String rht; String code=""; String cond;
    if (jj_mask_27[getToken(1).kind]) {
      jj_consume_token(PRINTLN);
      jj_consume_token(LPAREN);
      lft = StrExpr();
      jj_consume_token(RPAREN);
         return "    System.out.println("+lft+");\n";
    } else {
      jj_expLA1[27] = jj_gen;
      if (jj_mask_26[getToken(1).kind]) {
        jj_consume_token(PRINT);
        jj_consume_token(LPAREN);
        lft = StrExpr();
        jj_consume_token(RPAREN);
         return "    System.out.print("+lft+");\n";
      } else {
        jj_expLA1[26] = jj_gen;
        if (jj_mask_25[getToken(1).kind]) {
          jj_consume_token(IF);
          cond = CFormula(vlist);
          lft = NFormula(vlist);
         code="    if ("+cond+") "+lft;
         return code;
        } else {
          jj_expLA1[25] = jj_gen;
          if (jj_mask_24[getToken(1).kind]) {
            lft = Expr();
            if (jj_mask_23[getToken(1).kind]) {
              x = jj_consume_token(ASSIGN);
            } else {
              jj_expLA1[23] = jj_gen;
              if (jj_mask_22[getToken(1).kind]) {
                x = jj_consume_token(EQ);
              } else {
                jj_expLA1[22] = jj_gen;
                if (jj_mask_21[getToken(1).kind]) {
                  x = jj_consume_token(NE);
                } else {
                  jj_expLA1[21] = jj_gen;
                  if (jj_mask_20[getToken(1).kind]) {
                    x = jj_consume_token(GT);
                  } else {
                    jj_expLA1[20] = jj_gen;
                    if (jj_mask_19[getToken(1).kind]) {
                      x = jj_consume_token(LT);
                    } else {
                      jj_expLA1[19] = jj_gen;
                      if (jj_mask_18[getToken(1).kind]) {
                        x = jj_consume_token(GE);
                      } else {
                        jj_expLA1[18] = jj_gen;
                        if (jj_mask_17[getToken(1).kind]) {
                          x = jj_consume_token(LE);
                        } else {
                          jj_expLA1[17] = jj_gen;
                          jj_consume_token(-1);
                          throw new ParseError();
                        }
                      }
                    }
                  }
                }
              }
            }
            rht = Expr();
         if ("=".equals(x.image)) {
             code="    "+lft+" = "+rht+";\n";
         } else if ("==".equals(x.image)) {
             code="    if ("+lft+" != "+rht+") return false;\n";
         } else if ("!=".equals(x.image)) {
             code="    if ("+lft+" == "+rht+") return false;\n";
         } else if (">".equals(x.image)) {
             code="    if ("+lft+" <= "+rht+") return false;\n";
         } else if ("<".equals(x.image)) {
             code="    if ("+lft+" >= "+rht+") return false;\n";
         } else if (">=".equals(x.image)) {
             code="    if ("+lft+" < "+rht+") return false;\n";
         } else if ("<=".equals(x.image)) {
             code="    if ("+lft+" > "+rht+") return false;\n";
         }
         return code;
          } else {
            jj_expLA1[24] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_17 = new boolean[66];
  static {
    jj_mask_17[LE] = true;
  }
  static boolean[] jj_mask_18 = new boolean[66];
  static {
    jj_mask_18[GE] = true;
  }
  static boolean[] jj_mask_19 = new boolean[66];
  static {
    jj_mask_19[LT] = true;
  }
  static boolean[] jj_mask_20 = new boolean[66];
  static {
    jj_mask_20[GT] = true;
  }
  static boolean[] jj_mask_21 = new boolean[66];
  static {
    jj_mask_21[NE] = true;
  }
  static boolean[] jj_mask_22 = new boolean[66];
  static {
    jj_mask_22[EQ] = true;
  }
  static boolean[] jj_mask_23 = new boolean[66];
  static {
    jj_mask_23[ASSIGN] = true;
  }
  static boolean[] jj_mask_24 = new boolean[66];
  static {
    jj_mask_24[VIDENTIFIER] =
    jj_mask_24[INTEGER] =
    jj_mask_24[LPAREN] = true;
  }
  static boolean[] jj_mask_25 = new boolean[66];
  static {
    jj_mask_25[IF] = true;
  }
  static boolean[] jj_mask_26 = new boolean[66];
  static {
    jj_mask_26[PRINT] = true;
  }
  static boolean[] jj_mask_27 = new boolean[66];
  static {
    jj_mask_27[PRINTLN] = true;
  }
  
  final public String NFormula(Vector vlist) throws ParseError {
         String lft; String rht; String code="";
    if (jj_mask_30[getToken(1).kind]) {
      lft = Formula(vlist);
         return lft;
    } else {
      jj_expLA1[30] = jj_gen;
      if (jj_mask_29[getToken(1).kind]) {
        jj_consume_token(LBRACE);
        lft = Formula(vlist);
         code="{\n  "+lft;
        label_7:
        while (true) {
          if (jj_mask_28[getToken(1).kind]) {
            ;
          } else {
            jj_expLA1[28] = jj_gen;
            break label_7;
          }
          jj_consume_token(COMMA);
          rht = Formula(vlist);
         code=code+"  "+rht;
        }
        jj_consume_token(RBRACE);
         return code+"    }\n";
      } else {
        jj_expLA1[29] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_28 = new boolean[66];
  static {
    jj_mask_28[COMMA] = true;
  }
  static boolean[] jj_mask_29 = new boolean[66];
  static {
    jj_mask_29[LBRACE] = true;
  }
  static boolean[] jj_mask_30 = new boolean[66];
  static {
    jj_mask_30[PRINTLN] =
    jj_mask_30[PRINT] =
    jj_mask_30[IF] =
    jj_mask_30[VIDENTIFIER] =
    jj_mask_30[INTEGER] =
    jj_mask_30[LPAREN] = true;
  }
  
  final public String CFormula(Vector vlist) throws ParseError {
         Token x; String lft; String rht; String code="";
    if (jj_mask_40[getToken(1).kind]) {
      lft = Expr();
      if (jj_mask_39[getToken(1).kind]) {
        x = jj_consume_token(ASSIGN);
      } else {
        jj_expLA1[39] = jj_gen;
        if (jj_mask_38[getToken(1).kind]) {
          x = jj_consume_token(EQ);
        } else {
          jj_expLA1[38] = jj_gen;
          if (jj_mask_37[getToken(1).kind]) {
            x = jj_consume_token(NE);
          } else {
            jj_expLA1[37] = jj_gen;
            if (jj_mask_36[getToken(1).kind]) {
              x = jj_consume_token(GT);
            } else {
              jj_expLA1[36] = jj_gen;
              if (jj_mask_35[getToken(1).kind]) {
                x = jj_consume_token(LT);
              } else {
                jj_expLA1[35] = jj_gen;
                if (jj_mask_34[getToken(1).kind]) {
                  x = jj_consume_token(GE);
                } else {
                  jj_expLA1[34] = jj_gen;
                  if (jj_mask_33[getToken(1).kind]) {
                    x = jj_consume_token(LE);
                  } else {
                    jj_expLA1[33] = jj_gen;
                    jj_consume_token(-1);
                    throw new ParseError();
                  }
                }
              }
            }
          }
        }
      }
      rht = Expr();
         return lft+x.image+rht;
    } else {
      jj_expLA1[40] = jj_gen;
      if (jj_mask_32[getToken(1).kind]) {
        jj_consume_token(LBRACE);
        code = CFormula(vlist);
        label_8:
        while (true) {
          if (jj_mask_31[getToken(1).kind]) {
            ;
          } else {
            jj_expLA1[31] = jj_gen;
            break label_8;
          }
          jj_consume_token(COMMA);
          rht = CFormula(vlist);
         code=code+","+rht;
        }
        jj_consume_token(RBRACE);
         return "{"+code+"}";
      } else {
        jj_expLA1[32] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_31 = new boolean[66];
  static {
    jj_mask_31[COMMA] = true;
  }
  static boolean[] jj_mask_32 = new boolean[66];
  static {
    jj_mask_32[LBRACE] = true;
  }
  static boolean[] jj_mask_33 = new boolean[66];
  static {
    jj_mask_33[LE] = true;
  }
  static boolean[] jj_mask_34 = new boolean[66];
  static {
    jj_mask_34[GE] = true;
  }
  static boolean[] jj_mask_35 = new boolean[66];
  static {
    jj_mask_35[LT] = true;
  }
  static boolean[] jj_mask_36 = new boolean[66];
  static {
    jj_mask_36[GT] = true;
  }
  static boolean[] jj_mask_37 = new boolean[66];
  static {
    jj_mask_37[NE] = true;
  }
  static boolean[] jj_mask_38 = new boolean[66];
  static {
    jj_mask_38[EQ] = true;
  }
  static boolean[] jj_mask_39 = new boolean[66];
  static {
    jj_mask_39[ASSIGN] = true;
  }
  static boolean[] jj_mask_40 = new boolean[66];
  static {
    jj_mask_40[VIDENTIFIER] =
    jj_mask_40[INTEGER] =
    jj_mask_40[LPAREN] = true;
  }
  
  final public String Expr() throws ParseError {
         Token x=null; String lft; String rht="";
    if (jj_mask_43[getToken(1).kind]) {
      x = jj_consume_token(VIDENTIFIER);
         Object z=avDict.get(x.image.intern());
         if (z==MGTPPre.ANTE) {
             avDict.put(x.image.intern(),MGTPPre.IVAR);
             ivar.addElement(x.image);
         } else if (z==null) {
             avDict.put(x.image.intern(),MGTPPre.XVAR);
             xvar.addElement(x.image);
         }
         lft=x.image;
    } else {
      jj_expLA1[43] = jj_gen;
      if (jj_mask_42[getToken(1).kind]) {
        x = jj_consume_token(INTEGER);
         lft=x.image;
      } else {
        jj_expLA1[42] = jj_gen;
        if (jj_mask_41[getToken(1).kind]) {
          jj_consume_token(LPAREN);
          lft = Expr();
          jj_consume_token(RPAREN);
         lft="("+lft+")";
        } else {
          jj_expLA1[41] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
    if (jj_mask_48[getToken(1).kind]) {
      if (jj_mask_47[getToken(1).kind]) {
        x = jj_consume_token(PLUS);
      } else {
        jj_expLA1[47] = jj_gen;
        if (jj_mask_46[getToken(1).kind]) {
          x = jj_consume_token(MINUS);
        } else {
          jj_expLA1[46] = jj_gen;
          if (jj_mask_45[getToken(1).kind]) {
            x = jj_consume_token(STAR);
          } else {
            jj_expLA1[45] = jj_gen;
            if (jj_mask_44[getToken(1).kind]) {
              x = jj_consume_token(SLASH);
            } else {
              jj_expLA1[44] = jj_gen;
              jj_consume_token(-1);
              throw new ParseError();
            }
          }
        }
      }
      rht = Expr();
    } else {
      jj_expLA1[48] = jj_gen;
      ;
    }
         if (rht=="") {return lft;}
         return lft+x.image+rht;
  }

  static boolean[] jj_mask_41 = new boolean[66];
  static {
    jj_mask_41[LPAREN] = true;
  }
  static boolean[] jj_mask_42 = new boolean[66];
  static {
    jj_mask_42[INTEGER] = true;
  }
  static boolean[] jj_mask_43 = new boolean[66];
  static {
    jj_mask_43[VIDENTIFIER] = true;
  }
  static boolean[] jj_mask_44 = new boolean[66];
  static {
    jj_mask_44[SLASH] = true;
  }
  static boolean[] jj_mask_45 = new boolean[66];
  static {
    jj_mask_45[STAR] = true;
  }
  static boolean[] jj_mask_46 = new boolean[66];
  static {
    jj_mask_46[MINUS] = true;
  }
  static boolean[] jj_mask_47 = new boolean[66];
  static {
    jj_mask_47[PLUS] = true;
  }
  static boolean[] jj_mask_48 = new boolean[66];
  static {
    jj_mask_48[PLUS] =
    jj_mask_48[MINUS] =
    jj_mask_48[STAR] =
    jj_mask_48[SLASH] = true;
  }
  
  final public String StrExpr() throws ParseError {
         String s=""; String t;
    t = StrTerm();
         s=s+t;
    label_9:
    while (true) {
      if (jj_mask_49[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[49] = jj_gen;
        break label_9;
      }
      jj_consume_token(PLUS);
      t = StrTerm();
         s=s+"+"+t;
    }
         return s;
  }

  static boolean[] jj_mask_49 = new boolean[66];
  static {
    jj_mask_49[PLUS] = true;
  }
  
  final public String StrTerm() throws ParseError {
         Token x; String s;
    if (jj_mask_51[getToken(1).kind]) {
      x = jj_consume_token(STRING_LITERAL);
         return x.image;
    } else {
      jj_expLA1[51] = jj_gen;
      if (jj_mask_50[getToken(1).kind]) {
        s = PTerm();
         return "\""+s+"\"";
      } else {
        jj_expLA1[50] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_50 = new boolean[66];
  static {
    jj_mask_50[ANONVAR] =
    jj_mask_50[VIDENTIFIER] =
    jj_mask_50[CIDENTIFIER] =
    jj_mask_50[INTEGER] = true;
  }
  static boolean[] jj_mask_51 = new boolean[66];
  static {
    jj_mask_51[STRING_LITERAL] = true;
  }
  
  final public String PTerm() throws ParseError {
         Token x; String code=""; String a;
    if (jj_mask_56[getToken(1).kind]) {
      x = jj_consume_token(CIDENTIFIER);
         code=x.image;
      if (jj_mask_55[getToken(1).kind]) {
        jj_consume_token(LPAREN);
        a = PTermList();
        jj_consume_token(RPAREN);
         code=code+"("+a+")";
      } else {
        jj_expLA1[55] = jj_gen;
        ;
      }
         return code;
    } else {
      jj_expLA1[56] = jj_gen;
      if (jj_mask_54[getToken(1).kind]) {
        x = jj_consume_token(ANONVAR);
         return x.image;
      } else {
        jj_expLA1[54] = jj_gen;
        if (jj_mask_53[getToken(1).kind]) {
          x = jj_consume_token(VIDENTIFIER);
         return "\"+"+x.image+"+\"";
        } else {
          jj_expLA1[53] = jj_gen;
          if (jj_mask_52[getToken(1).kind]) {
            x = jj_consume_token(INTEGER);
         return x.image;
          } else {
            jj_expLA1[52] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_52 = new boolean[66];
  static {
    jj_mask_52[INTEGER] = true;
  }
  static boolean[] jj_mask_53 = new boolean[66];
  static {
    jj_mask_53[VIDENTIFIER] = true;
  }
  static boolean[] jj_mask_54 = new boolean[66];
  static {
    jj_mask_54[ANONVAR] = true;
  }
  static boolean[] jj_mask_55 = new boolean[66];
  static {
    jj_mask_55[LPAREN] = true;
  }
  static boolean[] jj_mask_56 = new boolean[66];
  static {
    jj_mask_56[CIDENTIFIER] = true;
  }
  
  final public String PTermList() throws ParseError {
         String t; String code="";
    t = PTerm();
         code=t;
    label_10:
    while (true) {
      if (jj_mask_57[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[57] = jj_gen;
        break label_10;
      }
      jj_consume_token(COMMA);
      t = PTerm();
         code=code+","+t;
    }
         return code;
  }

  static boolean[] jj_mask_57 = new boolean[66];
  static {
    jj_mask_57[COMMA] = true;
  }
  
  public MGTPPreTokenManager token_source;
  public Token token;
  private MGTPPre jj_me;
  private int jj_gen;
  private int[] jj_expLA1 = new int[58];

  public MGTPPre(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new MGTPPreTokenManager(input_stream);
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 58; i++) jj_expLA1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source.ReInit(input_stream);
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 58; i++) jj_expLA1[i] = -1;
  }

  public MGTPPre(MGTPPreTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 58; i++) jj_expLA1[i] = -1;
  }

  public void ReInit(MGTPPreTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 58; i++) jj_expLA1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    jj_token_error_setup(token, kind);
    throw new ParseError();
  }

  final public Token getNextToken() throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) throws ParseError {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final String jj_add_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      ch = str.charAt(i);
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

  protected int error_line;
  protected int error_column;
  protected String error_string;
  protected String[] expected_tokens;

  protected void token_error() {
    System.out.println("");
    System.out.println("Parse error at line " + error_line + ", column " + error_column + ".  Encountered:");
    System.out.println("    \"" + jj_add_escapes(error_string) + "\"");
    System.out.println("");
    if (expected_tokens.length == 1) {
      System.out.println("Was expecting:");
    } else {
      System.out.println("Was expecting one of:");
    }
    for (int i = 0; i < expected_tokens.length; i++) {
      System.out.println("    " + expected_tokens[i]);
    }
    System.out.println("");
  }

  private java.util.Vector jj_errortokens = new java.util.Vector();

  final private void jj_token_error_setup(Token current, int kind) throws ParseError {
    jj_errortokens.removeAllElements();
    boolean[] la1tokens = new boolean[66];
    boolean[] mask = null;
    for (int i = 0; i < 66; i++) {
      la1tokens[i] = false;
    }
    if (kind >= 0) la1tokens[kind] = true;
    for (int i = 0; i < 58; i++) {
      if (jj_expLA1[i] == jj_gen) {
        switch (i) {
          case 0: mask = jj_mask_0; break;
          case 1: mask = jj_mask_1; break;
          case 2: mask = jj_mask_2; break;
          case 3: mask = jj_mask_3; break;
          case 4: mask = jj_mask_4; break;
          case 5: mask = jj_mask_5; break;
          case 6: mask = jj_mask_6; break;
          case 7: mask = jj_mask_7; break;
          case 8: mask = jj_mask_8; break;
          case 9: mask = jj_mask_9; break;
          case 10: mask = jj_mask_10; break;
          case 11: mask = jj_mask_11; break;
          case 12: mask = jj_mask_12; break;
          case 13: mask = jj_mask_13; break;
          case 14: mask = jj_mask_14; break;
          case 15: mask = jj_mask_15; break;
          case 16: mask = jj_mask_16; break;
          case 17: mask = jj_mask_17; break;
          case 18: mask = jj_mask_18; break;
          case 19: mask = jj_mask_19; break;
          case 20: mask = jj_mask_20; break;
          case 21: mask = jj_mask_21; break;
          case 22: mask = jj_mask_22; break;
          case 23: mask = jj_mask_23; break;
          case 24: mask = jj_mask_24; break;
          case 25: mask = jj_mask_25; break;
          case 26: mask = jj_mask_26; break;
          case 27: mask = jj_mask_27; break;
          case 28: mask = jj_mask_28; break;
          case 29: mask = jj_mask_29; break;
          case 30: mask = jj_mask_30; break;
          case 31: mask = jj_mask_31; break;
          case 32: mask = jj_mask_32; break;
          case 33: mask = jj_mask_33; break;
          case 34: mask = jj_mask_34; break;
          case 35: mask = jj_mask_35; break;
          case 36: mask = jj_mask_36; break;
          case 37: mask = jj_mask_37; break;
          case 38: mask = jj_mask_38; break;
          case 39: mask = jj_mask_39; break;
          case 40: mask = jj_mask_40; break;
          case 41: mask = jj_mask_41; break;
          case 42: mask = jj_mask_42; break;
          case 43: mask = jj_mask_43; break;
          case 44: mask = jj_mask_44; break;
          case 45: mask = jj_mask_45; break;
          case 46: mask = jj_mask_46; break;
          case 47: mask = jj_mask_47; break;
          case 48: mask = jj_mask_48; break;
          case 49: mask = jj_mask_49; break;
          case 50: mask = jj_mask_50; break;
          case 51: mask = jj_mask_51; break;
          case 52: mask = jj_mask_52; break;
          case 53: mask = jj_mask_53; break;
          case 54: mask = jj_mask_54; break;
          case 55: mask = jj_mask_55; break;
          case 56: mask = jj_mask_56; break;
          case 57: mask = jj_mask_57; break;
        }
        for (int j = 0; j < 66; j++) {
          if (mask[j]) la1tokens[j] = true;
        }
      }
    }
    if (la1tokens[0]) {
      jj_errortokens.addElement(tokenImage[0] + " ");
    }
    for (int i = 1; i < 66; i++) {
      if (la1tokens[i]) {
        jj_errortokens.addElement(tokenImage[i] + " ...");
      }
    }
    expected_tokens = new String[jj_errortokens.size()];
    for (int i = 0; i < jj_errortokens.size(); i++) {
      expected_tokens[i] = (String)(jj_errortokens.elementAt(i));
    }
    error_line = current.beginLine;
    error_column = current.beginColumn;
    if (current.kind == 0) {
      error_string = tokenImage[0];
    } else {
      error_string = current.image;
    }
    jj_me.token_error();
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
