/**
 * Copyright (C) 1998 Hasegawa Ryuzo Lab., 
 *           Graduate School of Information Science and Electrical Engineering,
 *           Kyushu University
 */

/**
 * MGTP245 classes 7-Nov-1997
 * =========================================================================
 * Class name	Fields		Description		File
 * =========================================================================
 *							MGTPTerms.java
 * -------------------------------------------------------------------------
 * Term		name,arg,next	abstract term
 *   UATerm
 *   ATerm			atomic term
 *     ATermL
 *   ITerm			integer term
 *     ITermL
 *   AVar			anonymous variable
 *   AVarL
 *   BVar			bound variable
 *   BVarL
 *   FVar			free variable
 *   FVarL
 *   CTerm			compound term
 *     CTermL
 * -------------------------------------------------------------------------
 *							MGTPClauses.java
 * -------------------------------------------------------------------------
 * Clause	ante,cnsq	abstract clause
 *   PClause			positive clause
 *   NClause			negative clause
 *     ENClause			negative clause with an entry literal
 *     NXClause			negative clause with an external literal
 *     ENXClause		negative clause with entry&external literals
 *   MClause			mixed clause
 *     EMClause			mixed clause with an entry literal
 *     MXClause			mixed clause with an external literal
 *     EMXClause		mixed clause with entry&external literals
 * CList			list of clauses
 * Clauses			set of MGTP input clauses 
 * -------------------------------------------------------------------------
 *							MGTP.java
 * -------------------------------------------------------------------------
 * Model			list of ground atoms(terms)
 * TList			list of consequents
 * CnsqBuf			model extending cnsq-buffer
 * GStack			list(stack) of goals
 * MGTP				MGTP top-level
 * =========================================================================
 * 							MGTPDict.java
 * -------------------------------------------------------------------------
 * MGTPDict			dictionary
 * =========================================================================
 * 							MGTPParser.jj
 * -------------------------------------------------------------------------
 * MGTPParser			parser for MGTP input clauses
 * =========================================================================
 * 							MGTPPre.jj
 * -------------------------------------------------------------------------
 * MGTPPre			preprocessor for MGTP input clauses
 * =========================================================================
 */
