/* Generated By:JavaCC: Do not edit this line. MGTPParser.java */
import java.util.*;

public class MGTPParser implements MGTPParserConstants {
    static String version="2.4.3";
    static String TRUE="true".intern();
    static String FALSE="false".intern();
    static String DOM="dom/1".intern();
    MGTP mgtp;
    MGTPDict uatdict=new MGTPDict();
    MGTPDict vardict=new MGTPDict();
    boolean shared;
    Term ELiteral;
    int clsId=1;

    static public boolean readFrom(MGTP m, String args[]) {
         MGTPParser parser;

         if (args.length==0) {
             parser=new MGTPParser(System.in);
             parser.mgtp=m;
         } else if (args.length>=1) {
             System.out.println("\n"+args[0]);
             try {
                 parser=new MGTPParser(new java.io.FileInputStream(args[0]));
                 parser.mgtp=m;
             } catch (java.io.FileNotFoundException e) {
                 System.out.println(args[0]+" not found.");
                 return false;
             }
         } else {
             return false;
         }
         try {
             parser.CompilationUnit();
             return true;
         } catch (ParseError e) {
             return false;
         }
    }

    Term mkCTerm(String n, Vector v, int ln) {
         Term next; int i=v.size()-1;
         next=mkLast((Term)v.elementAt(i),ln);
         for (i=i-1; i>=0; i--) {
             ((Term)v.elementAt(i)).next=next;
             next=(Term)v.elementAt(i);
         }
         return new CTerm(n,next,null);
    }
    Term mkLast(Term t, int ln) {
         if (t instanceof ATerm) {return new ATermL(t.name);}
         else if (t instanceof ITerm) {return new ITermL(((ITerm)t).val);}
         else if (t instanceof AVar) {return new AVarL(t.name);}
         else if (t instanceof FVar) {
             Term v=new FVarL(t.name);
             vardict.put(t.name,new Vpair(ln,v)); return v;
         }
         else if (t instanceof BVar) {return new BVarL(t.name, t.arg);}
         else if (t instanceof CTerm) {return new CTermL(t.name, t.arg);}
         else if (t instanceof AssignFT) {
             return new AssignFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof EqFT) {return new EqFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof NeFT) {return new NeFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof GtFT) {return new GtFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof LtFT) {return new LtFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof GeFT) {return new GeFTL(t.arg.arg, t.arg.next);}
         else if (t instanceof LeFT) {return new LeFTL(t.arg.arg, t.arg.next);}
         else {return t;}
    }
    Term mkLiteral(Term t, int ln) {
         if (t instanceof ATerm) {return uatdict.uniUATerm(t.name);}
         else if (t instanceof ITerm) {return new ITermL(((ITerm)t).val);}
         else if (t instanceof AVar) {return new AVarL(t.name);}
         else if (t instanceof FVar) {
             Term v=new FVarL(t.name);
             vardict.put(t.name,new Vpair(ln,v)); return v;
         }
         else if (t instanceof BVar) {return new BVarL(t.name, t.arg);}
         else if (t instanceof CTerm) {return new CTermL(t.name, t.arg);}
         else {return t;}
    }

    Term mkFBVar(Term t, MGTPDict dic) {
         if (t instanceof UATerm||
             t instanceof ATermL||
             t instanceof ITermL||
             t instanceof AVarL) {
             return t;
         } else if (t instanceof ATerm) {
             return new ATerm(t.name, mkFBVar(t.next,dic));
         } else if (t instanceof ITerm) {
             return new ITerm(((ITerm)t).val, mkFBVar(t.next,dic));
         } else if (t instanceof AVar) {
             return new AVar(t.name, mkFBVar(t.next,dic));
         } else if (t instanceof FVarL) {
             return dic.euniVarL(t.name);
         } else if (t instanceof FVar) {
             Term v=dic.euniVar(t.name);
             v.next=mkFBVar(t.next, dic); return v;
         } else if (t instanceof BVarL) {
             return dic.euniVarL(t.name);
         } else if (t instanceof BVar) {
             Term v=dic.euniVar(t.name);
             v.next=mkFBVar(t.next, dic); return v;
         } else if (t instanceof CTermL) {
             return new CTermL(t.name,mkFBVar(t.arg,dic));
         } else if (t instanceof CTerm) {
             return new CTerm(t.name,mkFBVar(t.arg,dic),mkFBVar(t.next,dic));
         } else return t;
    }

    void mkEntClauses(Vector ant, Vector cns) {
         mkEClause(ant, cns);
         for (int i=1; i<ant.size(); i++) {
             Vector ent=(Vector)ant.clone();
             Term e=(Term)ent.elementAt(i);
             ent.removeElementAt(i);
             ent.insertElementAt(e,0);
             MGTPDict evdict=new MGTPDict();
             for (int j=0; j<ent.size(); j++) {
                 ent.setElementAt(mkFBVar((Term)ent.elementAt(j),evdict),j);
             }
             Vector ecns=(Vector)cns.clone();
             for (int j=0; j<ecns.size(); j++) {
                 ecns.setElementAt(mkFBVar((Term)ecns.elementAt(j),evdict),j);
             }
             mkEClause(ent, ecns);
         }
    }

    void mkEClause(Vector ant, Vector cns) {
         Term[] aa=new Term[ant.size()];
         ant.copyInto(aa);
         if (cns.size()==0) {
             if (ELiteral!=null) {
                 mgtp.negCls.add(new ENXClause(clsId,aa,ELiteral,mgtp));
                 clsId++;
             } else {
                 mgtp.negCls.add(new ENClause(clsId,aa,mgtp));
                 clsId++;
             }
         } else {
             Term[] ca=new Term[cns.size()]; cns.copyInto(ca);
             if (ELiteral!=null) {
                 mgtp.mixCls.add(new EMXClause(clsId,aa,ELiteral,ca,mgtp));
                 clsId++;
             } else {
                 mgtp.mixCls.add(new EMClause(clsId,aa,ca,mgtp));
                 clsId++;
             }
         }
    }

    void mkClause(Vector ant, Vector cns) {
         Term[] aa=new Term[ant.size()];
         ant.copyInto(aa);
         if (cns.size()==0) {
             if (ELiteral!=null) {
                 mgtp.negCls.add(new NXClause(clsId,aa,ELiteral,mgtp));
                 clsId++;
             } else {
                 mgtp.negCls.add(new NClause(clsId,aa,mgtp));
                 clsId++;
             }
         } else {
             Term[] ca=new Term[cns.size()]; cns.copyInto(ca);
             if (ELiteral!=null) {
                 mgtp.mixCls.add(new MXClause(clsId,aa,ELiteral,ca,mgtp));
                 clsId++;
             } else {
                 mgtp.mixCls.add(new MClause(clsId,aa,ca,mgtp));
                 clsId++;
             }
         }
    }

/*****************************************
 * THE MGTP LANGUAGE GRAMMAR STARTS HERE *
 *****************************************/
  final public void CompilationUnit() throws ParseError {
    label_1:
    while (true) {
      if (jj_mask_0[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[0] = jj_gen;
        break label_1;
      }
      Clause();
    }
    jj_consume_token(0);
  }

  static boolean[] jj_mask_0 = new boolean[61];
  static {
    jj_mask_0[ANONVAR] =
    jj_mask_0[VIDENTIFIER] =
    jj_mask_0[CIDENTIFIER] =
    jj_mask_0[INTEGER] =
    jj_mask_0[LBRACE] =
    jj_mask_0[IMPLIES] =
    jj_mask_0[LONGIMPLIES] = true;
  }
  
  final public void Clause() throws ParseError {
         Vector ant=new Vector();
         Vector cns=new Vector();
         vardict.clear();
         shared=false;
         ELiteral=null;
    if (jj_mask_1[getToken(1).kind]) {
      Antecedent(ant);
    } else {
      jj_expLA1[1] = jj_gen;
      ;
    }
    if (jj_mask_3[getToken(1).kind]) {
      jj_consume_token(IMPLIES);
    } else {
      jj_expLA1[3] = jj_gen;
      if (jj_mask_2[getToken(1).kind]) {
        jj_consume_token(LONGIMPLIES);
      } else {
        jj_expLA1[2] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
    if (jj_mask_4[getToken(1).kind]) {
      Consequent(cns);
    } else {
      jj_expLA1[4] = jj_gen;
      ;
    }
    jj_consume_token(DOT);
         if (ant.size()==0) {
             if (cns.size()==0) {
                 System.out.print("Empty clause found.\nUNSAT!\n");
             } else {
                 Term[] ca=new Term[cns.size()]; cns.copyInto(ca);
                 mgtp.posCls.add(new PClause(clsId,ca,mgtp));
                 clsId++;
             }
         } else {
             if (shared) {mkEntClauses(ant,cns);}
             else {mkClause(ant,cns);}
         }
  }

  static boolean[] jj_mask_1 = new boolean[61];
  static {
    jj_mask_1[ANONVAR] =
    jj_mask_1[VIDENTIFIER] =
    jj_mask_1[CIDENTIFIER] =
    jj_mask_1[INTEGER] =
    jj_mask_1[LBRACE] = true;
  }
  static boolean[] jj_mask_2 = new boolean[61];
  static {
    jj_mask_2[LONGIMPLIES] = true;
  }
  static boolean[] jj_mask_3 = new boolean[61];
  static {
    jj_mask_3[IMPLIES] = true;
  }
  static boolean[] jj_mask_4 = new boolean[61];
  static {
    jj_mask_4[ANONVAR] =
    jj_mask_4[VIDENTIFIER] =
    jj_mask_4[CIDENTIFIER] =
    jj_mask_4[INTEGER] =
    jj_mask_4[LBRACE] = true;
  }
  
  final public void Antecedent(Vector ant) throws ParseError {
         Term lit; int ln=0;
    lit = Literal(ln);
         if (lit!=null&&lit.name!=TRUE) {ant.addElement(lit);}
    label_2:
    while (true) {
      if (jj_mask_5[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[5] = jj_gen;
        break label_2;
      }
      jj_consume_token(COMMA);
         ln++;
      lit = Literal(ln);
         if (lit!=null&&lit.name!=TRUE) {ant.addElement(lit);}
    }
  }

  static boolean[] jj_mask_5 = new boolean[61];
  static {
    jj_mask_5[COMMA] = true;
  }
  
  final public void Consequent(Vector cns) throws ParseError {
         Term lit;
    lit = Literal(-1);
         if (lit!=null&&lit.name!=FALSE) {cns.addElement(lit);}
    label_3:
    while (true) {
      if (jj_mask_6[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[6] = jj_gen;
        break label_3;
      }
      if (jj_mask_8[getToken(1).kind]) {
        jj_consume_token(COMMA);
      } else {
        jj_expLA1[8] = jj_gen;
        if (jj_mask_7[getToken(1).kind]) {
          jj_consume_token(SEMICOLON);
        } else {
          jj_expLA1[7] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
      lit = Literal(-1);
         if (lit!=null&&lit.name!=FALSE) {cns.addElement(lit);}
    }
  }

  static boolean[] jj_mask_6 = new boolean[61];
  static {
    jj_mask_6[SEMICOLON] =
    jj_mask_6[COMMA] = true;
  }
  static boolean[] jj_mask_7 = new boolean[61];
  static {
    jj_mask_7[SEMICOLON] = true;
  }
  static boolean[] jj_mask_8 = new boolean[61];
  static {
    jj_mask_8[COMMA] = true;
  }
  
  final public Term Literal(int ln) throws ParseError {
         Term t;
    if (jj_mask_10[getToken(1).kind]) {
      t = Term(ln);
         return mkLiteral(t,ln);
    } else {
      jj_expLA1[10] = jj_gen;
      if (jj_mask_9[getToken(1).kind]) {
        ELiteral = ExternalLiteral();
         return null;
      } else {
        jj_expLA1[9] = jj_gen;
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_9 = new boolean[61];
  static {
    jj_mask_9[LBRACE] = true;
  }
  static boolean[] jj_mask_10 = new boolean[61];
  static {
    jj_mask_10[ANONVAR] =
    jj_mask_10[VIDENTIFIER] =
    jj_mask_10[CIDENTIFIER] =
    jj_mask_10[INTEGER] = true;
  }
  
  final public Term Term(int ln) throws ParseError {
         Token x; Vector tl=new Vector();
    if (jj_mask_15[getToken(1).kind]) {
      x = jj_consume_token(CIDENTIFIER);
      if (jj_mask_14[getToken(1).kind]) {
        jj_consume_token(LPAREN);
        TermList(tl,ln);
        jj_consume_token(RPAREN);
      } else {
        jj_expLA1[14] = jj_gen;
        ;
      }
         int a=tl.size();
         if (a==0) {return new ATerm(x.image.intern());}
         return mkCTerm((x.image+"/"+a).intern(), tl, ln);
    } else {
      jj_expLA1[15] = jj_gen;
      if (jj_mask_13[getToken(1).kind]) {
        x = jj_consume_token(ANONVAR);
         return new AVar(x.image, null);
      } else {
        jj_expLA1[13] = jj_gen;
        if (jj_mask_12[getToken(1).kind]) {
          x = jj_consume_token(VIDENTIFIER);
         return vardict.uniVar(x.image,ln,this);
        } else {
          jj_expLA1[12] = jj_gen;
          if (jj_mask_11[getToken(1).kind]) {
            x = jj_consume_token(INTEGER);
         return new ITerm(Integer.parseInt(x.image));
          } else {
            jj_expLA1[11] = jj_gen;
            jj_consume_token(-1);
            throw new ParseError();
          }
        }
      }
    }
  }

  static boolean[] jj_mask_11 = new boolean[61];
  static {
    jj_mask_11[INTEGER] = true;
  }
  static boolean[] jj_mask_12 = new boolean[61];
  static {
    jj_mask_12[VIDENTIFIER] = true;
  }
  static boolean[] jj_mask_13 = new boolean[61];
  static {
    jj_mask_13[ANONVAR] = true;
  }
  static boolean[] jj_mask_14 = new boolean[61];
  static {
    jj_mask_14[LPAREN] = true;
  }
  static boolean[] jj_mask_15 = new boolean[61];
  static {
    jj_mask_15[CIDENTIFIER] = true;
  }
  
  final public void TermList(Vector tl, int ln) throws ParseError {
         Term t;
    t = Term(ln);
         tl.addElement(t);
    label_4:
    while (true) {
      if (jj_mask_16[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[16] = jj_gen;
        break label_4;
      }
      jj_consume_token(COMMA);
      t = Term(ln);
         tl.addElement(t);
    }
  }

  static boolean[] jj_mask_16 = new boolean[61];
  static {
    jj_mask_16[COMMA] = true;
  }
  
/**
 * Extended MGTP clauses are allowed to be written nsuch as:
 *   p(X), {X1:=X+1, X1<=100} --> p(X1).
 */
  final public Term ExternalLiteral() throws ParseError {
         Term t; Term h; Term p; Term pp=null;
    jj_consume_token(LBRACE);
    t = Formula();
         h=t; p=t;
    label_5:
    while (true) {
      if (jj_mask_17[getToken(1).kind]) {
        ;
      } else {
        jj_expLA1[17] = jj_gen;
        break label_5;
      }
      jj_consume_token(COMMA);
      t = Formula();
         p.next=t; pp=p; p=t;
    }
    jj_consume_token(RBRACE);
         if (pp==null) {return mkLast(h,-1);}
         pp.next=mkLast(p,-1); return h;
  }

  static boolean[] jj_mask_17 = new boolean[61];
  static {
    jj_mask_17[COMMA] = true;
  }
  
  final public Term Formula() throws ParseError {
         Token x; Term lft; Term rht;
    lft = Expr();
    if (jj_mask_24[getToken(1).kind]) {
      x = jj_consume_token(ASSIGN);
    } else {
      jj_expLA1[24] = jj_gen;
      if (jj_mask_23[getToken(1).kind]) {
        x = jj_consume_token(EQ);
      } else {
        jj_expLA1[23] = jj_gen;
        if (jj_mask_22[getToken(1).kind]) {
          x = jj_consume_token(NE);
        } else {
          jj_expLA1[22] = jj_gen;
          if (jj_mask_21[getToken(1).kind]) {
            x = jj_consume_token(GT);
          } else {
            jj_expLA1[21] = jj_gen;
            if (jj_mask_20[getToken(1).kind]) {
              x = jj_consume_token(LT);
            } else {
              jj_expLA1[20] = jj_gen;
              if (jj_mask_19[getToken(1).kind]) {
                x = jj_consume_token(GE);
              } else {
                jj_expLA1[19] = jj_gen;
                if (jj_mask_18[getToken(1).kind]) {
                  x = jj_consume_token(LE);
                } else {
                  jj_expLA1[18] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseError();
                }
              }
            }
          }
        }
      }
    }
    rht = Expr();
         if (":=".equals(x.image)) {return new AssignFT(lft,rht);}
         if ("==".equals(x.image)) {return new EqFT(lft,rht);}
         if ("!=".equals(x.image)) {return new NeFT(lft,rht);}
         if (">".equals(x.image)) {return new GtFT(lft,rht);}
         if ("<".equals(x.image)) {return new LtFT(lft,rht);}
         if (">=".equals(x.image)) {return new GeFT(lft,rht);}
         if ("<=".equals(x.image)) {return new LeFT(lft,rht);}
         return null;
  }

  static boolean[] jj_mask_18 = new boolean[61];
  static {
    jj_mask_18[LE] = true;
  }
  static boolean[] jj_mask_19 = new boolean[61];
  static {
    jj_mask_19[GE] = true;
  }
  static boolean[] jj_mask_20 = new boolean[61];
  static {
    jj_mask_20[LT] = true;
  }
  static boolean[] jj_mask_21 = new boolean[61];
  static {
    jj_mask_21[GT] = true;
  }
  static boolean[] jj_mask_22 = new boolean[61];
  static {
    jj_mask_22[NE] = true;
  }
  static boolean[] jj_mask_23 = new boolean[61];
  static {
    jj_mask_23[EQ] = true;
  }
  static boolean[] jj_mask_24 = new boolean[61];
  static {
    jj_mask_24[ASSIGN] = true;
  }
  
  final public Term Expr() throws ParseError {
         Token x=null; Term lft; Term rht=null;
    if (jj_mask_27[getToken(1).kind]) {
      x = jj_consume_token(VIDENTIFIER);
         lft=mkLast(vardict.uniVar(x.image,-1,this),-1);
    } else {
      jj_expLA1[27] = jj_gen;
      if (jj_mask_26[getToken(1).kind]) {
        x = jj_consume_token(INTEGER);
         lft=new ITermL(Integer.parseInt(x.image));
      } else {
        jj_expLA1[26] = jj_gen;
        if (jj_mask_25[getToken(1).kind]) {
          jj_consume_token(LPAREN);
          lft = Expr();
          jj_consume_token(RPAREN);
        } else {
          jj_expLA1[25] = jj_gen;
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
    if (jj_mask_32[getToken(1).kind]) {
      if (jj_mask_31[getToken(1).kind]) {
        x = jj_consume_token(PLUS);
      } else {
        jj_expLA1[31] = jj_gen;
        if (jj_mask_30[getToken(1).kind]) {
          x = jj_consume_token(MINUS);
        } else {
          jj_expLA1[30] = jj_gen;
          if (jj_mask_29[getToken(1).kind]) {
            x = jj_consume_token(STAR);
          } else {
            jj_expLA1[29] = jj_gen;
            if (jj_mask_28[getToken(1).kind]) {
              x = jj_consume_token(SLASH);
            } else {
              jj_expLA1[28] = jj_gen;
              jj_consume_token(-1);
              throw new ParseError();
            }
          }
        }
      }
      rht = Expr();
    } else {
      jj_expLA1[32] = jj_gen;
      ;
    }
         if (rht==null) {return lft;}
         if ("+".equals(x.image)) {return new PlusET(lft,rht);}
         if ("-".equals(x.image)) {return new MinusET(lft,rht);}
         if ("*".equals(x.image)) {return new TimesET(lft,rht);}
         if ("/".equals(x.image)) {return new DivET(lft,rht);}
         return null;
  }

  static boolean[] jj_mask_25 = new boolean[61];
  static {
    jj_mask_25[LPAREN] = true;
  }
  static boolean[] jj_mask_26 = new boolean[61];
  static {
    jj_mask_26[INTEGER] = true;
  }
  static boolean[] jj_mask_27 = new boolean[61];
  static {
    jj_mask_27[VIDENTIFIER] = true;
  }
  static boolean[] jj_mask_28 = new boolean[61];
  static {
    jj_mask_28[SLASH] = true;
  }
  static boolean[] jj_mask_29 = new boolean[61];
  static {
    jj_mask_29[STAR] = true;
  }
  static boolean[] jj_mask_30 = new boolean[61];
  static {
    jj_mask_30[MINUS] = true;
  }
  static boolean[] jj_mask_31 = new boolean[61];
  static {
    jj_mask_31[PLUS] = true;
  }
  static boolean[] jj_mask_32 = new boolean[61];
  static {
    jj_mask_32[PLUS] =
    jj_mask_32[MINUS] =
    jj_mask_32[STAR] =
    jj_mask_32[SLASH] = true;
  }
  
  public MGTPParserTokenManager token_source;
  public Token token;
  private MGTPParser jj_me;
  private int jj_gen;
  private int[] jj_expLA1 = new int[33];

  public MGTPParser(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new MGTPParserTokenManager(input_stream);
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_expLA1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    ASCII_UCodeESC_CharStream input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source.ReInit(input_stream);
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_expLA1[i] = -1;
  }

  public MGTPParser(MGTPParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_me = this;
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_expLA1[i] = -1;
  }

  public void ReInit(MGTPParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_gen = 0;
    for (int i = 0; i < 33; i++) jj_expLA1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    jj_token_error_setup(token, kind);
    throw new ParseError();
  }

  final public Token getNextToken() throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) throws ParseError {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final String jj_add_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      ch = str.charAt(i);
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

  protected int error_line;
  protected int error_column;
  protected String error_string;
  protected String[] expected_tokens;

  protected void token_error() {
    System.out.println("");
    System.out.println("Parse error at line " + error_line + ", column " + error_column + ".  Encountered:");
    System.out.println("    \"" + jj_add_escapes(error_string) + "\"");
    System.out.println("");
    if (expected_tokens.length == 1) {
      System.out.println("Was expecting:");
    } else {
      System.out.println("Was expecting one of:");
    }
    for (int i = 0; i < expected_tokens.length; i++) {
      System.out.println("    " + expected_tokens[i]);
    }
    System.out.println("");
  }

  private java.util.Vector jj_errortokens = new java.util.Vector();

  final private void jj_token_error_setup(Token current, int kind) throws ParseError {
    jj_errortokens.removeAllElements();
    boolean[] la1tokens = new boolean[61];
    boolean[] mask = null;
    for (int i = 0; i < 61; i++) {
      la1tokens[i] = false;
    }
    if (kind >= 0) la1tokens[kind] = true;
    for (int i = 0; i < 33; i++) {
      if (jj_expLA1[i] == jj_gen) {
        switch (i) {
          case 0: mask = jj_mask_0; break;
          case 1: mask = jj_mask_1; break;
          case 2: mask = jj_mask_2; break;
          case 3: mask = jj_mask_3; break;
          case 4: mask = jj_mask_4; break;
          case 5: mask = jj_mask_5; break;
          case 6: mask = jj_mask_6; break;
          case 7: mask = jj_mask_7; break;
          case 8: mask = jj_mask_8; break;
          case 9: mask = jj_mask_9; break;
          case 10: mask = jj_mask_10; break;
          case 11: mask = jj_mask_11; break;
          case 12: mask = jj_mask_12; break;
          case 13: mask = jj_mask_13; break;
          case 14: mask = jj_mask_14; break;
          case 15: mask = jj_mask_15; break;
          case 16: mask = jj_mask_16; break;
          case 17: mask = jj_mask_17; break;
          case 18: mask = jj_mask_18; break;
          case 19: mask = jj_mask_19; break;
          case 20: mask = jj_mask_20; break;
          case 21: mask = jj_mask_21; break;
          case 22: mask = jj_mask_22; break;
          case 23: mask = jj_mask_23; break;
          case 24: mask = jj_mask_24; break;
          case 25: mask = jj_mask_25; break;
          case 26: mask = jj_mask_26; break;
          case 27: mask = jj_mask_27; break;
          case 28: mask = jj_mask_28; break;
          case 29: mask = jj_mask_29; break;
          case 30: mask = jj_mask_30; break;
          case 31: mask = jj_mask_31; break;
          case 32: mask = jj_mask_32; break;
        }
        for (int j = 0; j < 61; j++) {
          if (mask[j]) la1tokens[j] = true;
        }
      }
    }
    if (la1tokens[0]) {
      jj_errortokens.addElement(tokenImage[0] + " ");
    }
    for (int i = 1; i < 61; i++) {
      if (la1tokens[i]) {
        jj_errortokens.addElement(tokenImage[i] + " ...");
      }
    }
    expected_tokens = new String[jj_errortokens.size()];
    for (int i = 0; i < jj_errortokens.size(); i++) {
      expected_tokens[i] = (String)(jj_errortokens.elementAt(i));
    }
    error_line = current.beginLine;
    error_column = current.beginColumn;
    if (current.kind == 0) {
      error_string = tokenImage[0];
    } else {
      error_string = current.image;
    }
    jj_me.token_error();
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
